﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

namespace SGLF.Core.Helpers
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    internal class Swapable<T>
    {
        // ==================================================================================================
        // Members
        // ==================================================================================================

        private T[] objects = new T[2];
        private int current = 0;

        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public T First
        {
            get
            {
                return objects[0];
            }
            set
            {
                objects[0] = value;
            }
        }

        public T Second
        {
            get
            {
                return objects[1];
            }
            set
            {
                objects[1] = value;
            }
        }

        public T Front
        {
            get
            {
                return objects[current];
            }
        }

        public T Back
        {
            get
            {
                return objects[1 - current];
            }
        }

        // ==================================================================================================
        // Methods
        // ==================================================================================================

        public void Swap()
        {
            current = (1 - current);
        }
    }
}