﻿// TODO: Header

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dependencies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using SGLF.Graphics.Shaders;

namespace SGLF.Graphics.Materials
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Classes
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public class Material : GraphicsResource
    {
        // ==================================================================================================
        // Properties
        // ==================================================================================================

        public UberProgram Program
        {
            get;
            set;
        }

        public UniformSet UniformSet
        {
            get;
            private set;
        }

        // ==================================================================================================
        // Constructor
        // ==================================================================================================

        public Material()
        {
            Program = null;
            UniformSet = new UniformSet();
        }

        public Material(UberProgram program, UniformSet uniforms)
        {
            Program = program;
            UniformSet = new UniformSet(uniforms.Uniforms);
        }
    }
}