﻿using System;

namespace SGLF.Core.Extensions
{
    public static class Int32Extensions
    {
        public static bool GetBit(this Int32 value, int index)
        {
            return ((value >> index) & 1) != 0;
        }

        public static Int32 SetBit(this Int32 value, int index, bool state)
        {
            if (state == true)
                return value | (1 << index);
            else
                return value & ~(1 << index);
        }
    }
}