#version 420

// ----------------------------------------------------------------------------
// Includes
// ----------------------------------------------------------------------------

#include <Common.inc>

// ----------------------------------------------------------------------------
// Attributes
// ----------------------------------------------------------------------------

in vec3 vPosition;
in vec2 vTexCoord;

layout(location = 0) out vec4 fGBuffer1;
layout(location = 1) out vec4 fGBuffer2;
layout(location = 2) out vec4 fGBuffer3;
layout(location = 3) out vec4 fGBuffer4;


// ----------------------------------------------------------------------------
// Functions
// ----------------------------------------------------------------------------

void main()
{
    fGBuffer1 = vec4(0, 0, 0, 0);
    fGBuffer2 = vec4(0, 0, 0, 0);
    fGBuffer3 = vec4(uScene.ClearColor, 0);
	fGBuffer4 = vec4(0, 0, 0, 1);
	gl_FragDepth = 1.0;
}